// contact me if you need help understanding the functions, xeen
var rdr = {
	lang: function(v) {
		return document.getElementById("redirremlocale").getString(v);
	},
	
	init: function () {
		this.prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.redirrem.');
		this.oldsettings();
		
		var whitelistdev = "@@^http://.*\.extenzilla\.it.* @@/babelfish/trurl_pagecontent?url http://search.msn. http://web.archive.org/web/ http://search.aol.com @@euroseek.com/system/viewimg.cgi\?rm http://jproxy.uol.com.ar @@^https?://.*\.google\..* @@^http://.*.wrs.yahoo.com.*/l=..../; @@^http://(validator|jigsaw).w3.org http://*.php.net/manual/add-note.php? 4players.de*comment https://login.yahoo. javascript:multi_page_jump";		
		var blacklistdev = "http://*.giga.de";
		
	  if(!this.prefs.prefHasUserValue("ver"))    						    this.prefs.setCharPref("ver", '0.4'); // also change in prevs on import!
	  if(!this.prefs.prefHasUserValue("active"))    						this.prefs.setBoolPref("active", true);
		if(!this.prefs.prefHasUserValue("menu.addtolist")) 				this.prefs.setBoolPref("menu.addtolist", false);
		if(!this.prefs.prefHasUserValue("menu.visit")) 						this.prefs.setBoolPref("menu.visit", false);
		if(!this.prefs.prefHasUserValue("beta.cleanimages"))      this.prefs.setBoolPref("beta.cleanimages", false);
		if(!this.prefs.prefHasUserValue("beta.cleanurl"))      		this.prefs.setBoolPref("beta.cleanurl", false);
		if(!this.prefs.prefHasUserValue("highlight.nowhitelist")) this.prefs.setBoolPref("highlight.nowhitelist", true);
		if(!this.prefs.prefHasUserValue("highlight.clean"))    		this.prefs.setBoolPref("highlight.clean", true);
		if(!this.prefs.prefHasUserValue("highlight.unclean"))    	this.prefs.setBoolPref("highlight.unclean", true);
		if(!this.prefs.prefHasUserValue("blacklisttoggle")) 			this.prefs.setBoolPref("blacklisttoggle", false);
																								 							this.prefs.setBoolPref("reloadit", true);
		if(!this.prefs.prefHasUserValue("highlight.cleanstyle"))
					this.prefs.setCharPref("highlight.cleanstyle", 'background:#FFEAD9;color:#006400;');
		if(!this.prefs.prefHasUserValue("whitelist")) 						this.prefs.setCharPref("whitelist", whitelistdev);
		if(!this.prefs.prefHasUserValue("blacklist")) 						this.prefs.setCharPref("blacklist", blacklistdev);
		if(!this.prefs.prefHasUserValue("highlight.uncleanstyle"))
					this.prefs.setCharPref("highlight.uncleanstyle", 'color:#660000;background:#FFCC99;');
		
		if(this.prefs.getBoolPref("active")) this.active=true; else this.active=false;
		if(this.prefs.getBoolPref("highlight.clean") || this.prefs.getBoolPref("highlight.unclean")) this.highlight=true; else this.highlight=false;

		window.addEventListener("focus", function(event) { rdr.parse(event.originalTarget); },true);
		window.addEventListener("load" , function(event) { rdr.parse(event.originalTarget); },true);
		if(this.prefs.getBoolPref("beta.cleanimages")) {
		  window.addEventListener("load" , function(event) { rdr.imgclean(event.originalTarget); },true);
			this.d('Set to clean images. '+this.lang('beta'));
		}
		if(this.prefs.getBoolPref("beta.cleanurl")) {
		  window.addEventListener("load" , function(event) { rdr.urlclean(event.originalTarget); },true);
			this.d('Set to clean URLs. '+this.lang('beta'));
		}

		/*try {
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function() { rdr.context(); }, false);
		} catch(err) { }	*/	
	},
	
	oldsettings: function() {
		if(this.prefs.prefHasUserValue("ver") || !this.prefs.prefHasUserValue("active")) return true; 
		
		var temp,temp2,i;
		if(this.prefs.prefHasUserValue("whitelist")) {
			temp=this.prefs.getCharPref("whitelist").split(' ');
			temp2='';
			for(i=0;i<temp.length;i++) temp2=temp2+' @@'+temp[i];
			this.prefs.setCharPref("whitelist",temp2.trim());
		}
		if(this.prefs.prefHasUserValue("highlight")) {
			this.prefs.setBoolPref("highlight.clean", this.prefs.getBoolPref("highlight"));
			this.prefs.setBoolPref("highlight.unclean", false); //overwrite standard setting to get rdr0.32 behaviour
			this.prefs.clearUserPref('highlight');
		}
		if(this.prefs.prefHasUserValue("linksh")) {
			this.prefs.setCharPref("highlight.cleanstyle", this.prefs.getCharPref("linksh").replace(/\s!important/g,''));
		  this.prefs.clearUserPref('linksh');
		}
		this.prefs.setCharPref('ver','0.4');
		this.prefs.clearUserPref('antiblockrandom');
		return true;
  },
	
	rot13: function(s){
    var list='abcdefghijklmnopqrstuvwxyzabcdefghijklm',rot13,r;
		s=s.toLowerCase();
    for (var x = 0; x <= s.length; x++){
      rot13 = s.substring(x, x+1);
      if (rot13 >= 'a' && rot13 <= 'z') rot13 = list.charAt(list.indexOf(rot13) + 13);
      r+=rot13;
    }
		return r;
  },	

	imgclean: function(e) {
		if(e.location.href.indexOf('chrome://')=="0" || e.location.href.indexOf('about:')=="0") {
			e.rdrfailedurl=true;
		  return false;
		}
		// this.setItemAttr( "context-setWallpaper", "disabled", (("complete" in this.target) && !this.target.complete) ? "true" : null );
		var x,k,q,p,y;
		for(k=0;x=e.images[k];k++) {
			q=x.src.replace(/[%]3A/ig,':').replace(/[%]2f/ig,'/');
			if(q.indexOf('uggc://')>0) q=this.rot13(q);
			p=this.getredirect(q);
			this.d(k+'      '+q+'     '+p);
			if(p) {
				x.src=p;
			}
		}
		return true;
	},
	
  urlclean: function(e) {
		var noredirect=this.getredirect(e.location.href.replace(/[%]3A/ig,':').replace(/[%]2f/ig,'/'));
		if(!noredirect) return true;
		
		var bwt=this.prefs.getBoolPref("blacklisttoggle");
		
		if(!bwt) {
			var list=this.prefs.getCharPref("whitelist").split(' ');			
		 for(y=0;y<list.length;y++) if(rdrmatch(list[y],e.location.href).length) return true;
			this.d(noredirect);
		} else return true;
    if(confirm('The page you\'re on contains a redirect. Would you like to visit the cleaned link?')) e.location.href=noredirect;
		return true;
	},
	
	context: function() {
		if(!gContextMenu || !gContextMenu.onLink) {
			document.getElementById('redirrem-addlink').hidden=true;
			document.getElementById('redirrem-visitnormal').hidden=true;
			document.getElementById('redirrem-visitcleaned').hidden=true; 
			return true;
		}
		var node=document.popupNode;
		
		// If the a element contains others we need to get the a element first	
		while(!node.rdrprocessed) node=node.parentNode;
		
		var blacklisttoggle=this.prefs.getBoolPref('blacklisttoggle');
		if(((node.rdrhasredirect && !blacklisttoggle) || blacklisttoggle) && !node.rdrisonlist && this.prefs.getBoolPref('menu.addtolist')) {
		  document.getElementById('redirrem-addlink').hidden=false;
			try{document.getElementById('redirrem-addlink').visible=true;}catch(err){this.d(err);}
			this.temprightclickurl=node.rdrsavedurl;
		} else document.getElementById('redirrem-addlink').hidden=true;

		if(node.rdrhasredirect && node.rdriscleaned && this.prefs.getBoolPref('menu.visit')) {
		  document.getElementById('redirrem-visitnormal').hidden=false;
			try{document.getElementById('redirrem-addlink').visible=true;}catch(err){this.d(err);}
			this.temprightclickurl=node.rdrsavedurl;
		} else document.getElementById('redirrem-visitnormal').hidden=true;
		
		if(node.rdrhasredirect && !node.rdriscleaned && this.prefs.getBoolPref('menu.visit')) {
		  document.getElementById('redirrem-visitcleaned').hidden=false;
			try{document.getElementById('redirrem-addlink').visible=true;}catch(err){this.d(err);}
			this.temprightclickcleanurl=node.rdrfiltered;
		} else document.getElementById('redirrem-visitcleaned').hidden=true;
		
		return true;
	},
	
	visitlink: function(t) {
		var link=t ? this.temprightclickcleanurl : this.temprightclickurl;
		openNewTabWith(link, null, null, true);
	},
	
	openadd: function() {
		window.openDialog('chrome://redirectremover/content/add.xul','','chrome,modal,centerscreen','add','nopref',this.temprightclickurl);
	},
	
	catchframes: function (e) {
		var array=new Array();
		var i=1;
		array[0]=e.document;
		if (!("frames" in e) || e.frames.length <= 0) return array;
		
	  for (var f = 0; f < e.frames.length; f++) {
			try {
				fr=this.catchframes(e.frames[f]);						
				for(var g=0;g<fr.length;g++) {
					if(fr[g]) {
						array[i]=fr[g];
						i++;
					}
				}
			} catch(err) { }
		}  		
	
		return array;
	},
	
	toggle: function (change) {
		var array,f;
		array=this.catchframes(window.content);
		if((!this.active && !change) ||(this.active && change)) {
			this.active=false;
			for (f = 0; f < array.length; f++) this.unclean(array[f]);
		} else {
			this.active=true;
			for (f = 0; f < array.length; f++) this.clean(array[f]);
		}
	  this.setbutton();
	},
	
	hlt: function (event,change) {
		if(event.button!=1) return true;
		var array,f;
		array=this.catchframes(window.content);
		if((!this.highlight && !change) ||(this.highlight && change)) {
			this.highlight=false;			
			for (f = 0; f < array.length; f++) this.unhighlight(array[f]);
		} else {
			this.highlight=true;
			for (f = 0; f < array.length; f++) this.highlightit(array[f]);
		}
	  this.setbutton();
		return true;
	},
	
	setbutton: function () {
		if(this.active) {
			status='on-';
			text=this.lang('stopcleaning')+' ';
		} else {
			status='off-';
			text=this.lang('startcleaning')+' ';
		}
		if(this.highlight) {
		  status+='on';
			text+=this.lang('stophighlighting');
		} else {
			status+='off';
			text+=this.lang('starthighlighting');
	  }
		if(window.document.getElementById("redirrem-button") != undefined) {
			window.document.getElementById("redirrem-button").setAttribute("status",status);
			window.document.getElementById("redirrem-button").setAttribute("tooltiptext",text);
		}
	},
	
	parse: function(e) {
		if(this.prefs.getBoolPref("reloadit")) {
		  if(this.prefs.getBoolPref("active")) this.active=true; else this.active=false;
		  if(this.prefs.getBoolPref("highlight.clean") || this.prefs.getBoolPref("highlight.unclean")) this.highlight=true; else this.highlight=false;
		  this.setbutton();
			this.prefs.setBoolPref("reloadit",false);
		}
		
		if(e.location == undefined) return false;
		if(e.location.href.indexOf('chrome://')=="0" || e.location.href.indexOf('about:')=="0") {
			e.rdrfailedurl=true;
		  return false;
		}		
		
		var k,x,p,q,isonlist,list;
		
		if(!this.prefs.getBoolPref("blacklisttoggle"))
			list=this.prefs.getCharPref("whitelist").split(' ');
		else
			list=this.prefs.getCharPref("blacklist").split(' ');
		if(0 > e.rdrlastcleanedlinks) e.rdrlastcleanedlinks=0;
		
		for(k=0;x=e.links[k];k++) {
			if(x.rdrprocessed) continue;
			x.rdrprocessed=true;
			q=x.href.replace(/[%]3A/ig,':').replace(/[%]2f/ig,'/');
			p=this.getredirect(q);			
			if(p) {
				isonlist=false;
				for(y=0;y<list.length && isonlist == false;y++) if(rdrmatch(list[y],q).length) isonlist=true;
				x.rdrhasredirect	=true;
				x.rdrfiltered			=p;
				x.rdrsavedurl			=x.href;
				x.rdrsavedstyle		=x.style.cssText;
				x.rdrisonlist			=isonlist;
				x.rdriscleaned		=false;
				x.rdrishighlighted=false;
			}
		}
		e.rdrlastcleanedlinks=k;

		if(this.active) this.clean(e); else this.unclean(e);
		if(this.highlight) this.highlightit(e); else this.unhighlight(e);
		return true;
	},
	
	getredirect: function(q) {
		var z,i,jslink,t,j,p;
		var strings = new Array('http://','ftp://','?www.','=www.');
    for(z=0;z<strings.length;z++) {
			i=q.lastIndexOf(strings[z]);
		  if(i>0) {
				jslink=false;
				if(q.indexOf('javascript:')=="0") { i--; jslink=true; }
			  t=q.substring(i);
				if(t.indexOf('?')=="-1") {
					j=t.indexOf('&');					
			    if(j>0) t=t.substring(0,j);
				}					
				if(jslink) {
					p=/('|")((https?:\/\/|ftp:\/\/|www\.)([\w#$-.+!*'()@:?=&\/;~]|\\')*?)("|('\s*[,;)]))/.exec(t);
					p[2]=p[2].replace(/\\'/g,"'");
				} else {
					p=/()((https?:\/\/|ftp:\/\/|www\.)[\w#$-.+!*'()@:?=&\/;~]*)/.exec(t);
				}
				if(p) {
					if(p[2].indexOf('www.')==0) p[2]='http://'+p[2];
					return p[2].replace(/\&amp;/ig,'&').replace(/[%]3F/ig,'?').replace(/[%]3D/ig,'=').replace(/[%]26/ig,'&');
				}
		  }
		}
		return null;
	},
	
	highlightit: function(e) {
		if(e.rdrfailedurl) return true;
		var k,clean,unclean,cleanstyle,uncleanstyle,nowhitelist,blacklisttoggle;
		cleanstyle = this.prefs.getCharPref("highlight.cleanstyle");
		uncleanstyle = this.prefs.getCharPref("highlight.uncleanstyle");
		clean = this.prefs.getBoolPref("highlight.clean");
		nowhitelist = this.prefs.getBoolPref("highlight.nowhitelist");
		blacklisttoggle = this.prefs.getBoolPref("blacklisttoggle");
		unclean = this.prefs.getBoolPref("highlight.unclean");
    for(k=0;x=e.links[k];k++) {
			if(!x.rdrhasredirect || x.rdrishighlighted || (x.rdriscleaned && !clean) || (!x.rdriscleaned && !unclean) || (nowhitelist && !blacklisttoggle && x.rdrisonlist)) continue;
			x.rdrishighlighted=true;
			if(x.rdriscleaned) x.style.cssText=cleanstyle; else x.style.cssText=uncleanstyle;
		}
		return true;
	},

	unhighlight: function(e) {
    if(e.rdrfailedurl) return true;
		
    for(k=0;x=e.links[k];k++) {
			if(!x.rdrhasredirect || !x.rdrishighlighted) continue;
			x.rdrishighlighted=false;
			x.style.cssText=x.rdrsavedstyle;
		}
		return true;
	},
	
	clean: function (e) {
		if(e.rdrfailedurl) return true;
		var blacklisttoggle=this.prefs.getBoolPref("blacklisttoggle");		
    for(k=0;x=e.links[k];k++) {
			if(!x.rdrhasredirect || x.rdriscleaned || (x.rdrisonlist && !blacklisttoggle) || (!x.rdrisonlist && blacklisttoggle) ) continue;
			x.rdriscleaned=true;
			if(this.highlight) x.rdrishighlighted=false;
			x.href=x.rdrfiltered;
		}
		if(this.highlight) this.highlightit(e);
		return true;
	},
	
	unclean: function (e) {
		if(e.rdrfailedurl) return true;
    for(k=0;x=e.links[k];k++) {
			if(!x.rdrhasredirect || !x.rdriscleaned) continue;
			if(this.highlight) x.rdrishighlighted=false;
			x.rdriscleaned=false;
			x.href=x.rdrsavedurl;
		}
		if(this.highlight) this.highlightit(e);
		return true;
	},
	
	d: function(t) {
	  Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('rdr: '+t);
  },
	
	initmenu: function() {
    try {
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", function() { rdr.context(); }, false);
		} catch(err) {}
	  window.removeEventListener("load", rdr.initmenu, false);
	}
	
	
}

rdr.init();
window.addEventListener("load",function() { rdr.initmenu(); }, false);
